//+------------------------------------------------------------------+
//|                                       MTF Trendinator  1.0.1.mq4 |
//|                                                                  |
/*
Shows Trends of all timeframes in a grid. 

Gives 'Trendscore' for each timeframe from 0 to 20. 
0=Strong down trend 10=neutral, 20 Strong up trend

Overall trendscore 0 - 180 (top right corner) 

Uses - MA , Stochastic, CCI, RSI, MACD


Based on 'ZMFX Forex Trend v3'
https://www.mql5.com/en/code/10206


//found this useful? consider buying me a beer :) - https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=MY5PF2BQH8WZW


//------------------------------------------------------

Revision History

v1.0.1 - 5/12/2014 
Fixed minor typo in MA M1 code which had ema1 and ema2 switched, which caused incorrect trend to be displayed.

*/
//+------------------------------------------------------------------+
#property copyright "Trendinator Industries"

#property indicator_chart_window
#define Pref "MTF-Trendinator"  //change this value and compile to use multiple Trendintors on one chart ie. MTF-Trendinator1, MTF-Trendinator2... 


extern bool CurrentSymbol=True;  //use current symbol of chart?
extern string Alternate_Symbol="If CurrentSymbol=False, select symbol";
extern string symbol="EURUSD";   // use other symbol - active when CurrentSymbol=False
string symbol1="_Symbol";


// turn labels on or off
extern bool drawSymbol=True; //draw symbol name
extern bool drawLabels=True; //draw indicator name labels
extern bool drawTimeframes=True; // draw timeframe labels
extern bool drawScore=True; // draw scores


extern string note1="Coordinates:";
extern int X=-10;       // X Position
extern int Y=50;         //Y Position
extern int X_Space=200; //Horizontal Spacing
extern int Y_Space=200; //Vertical Spacing
extern int Corner=0;    

extern string note2="Windings Code for arrow";
extern string note3="233=up arrow 234=down arrow 110=square";
extern   int arrowCodeUp=110;
extern   int arrowCodeDown=110;  
extern   int arrowSize=20;


extern string note5="Indicator Parameters:";
extern   int EMA1_period=10;
extern   int EMA2_period=50;
extern   int EMA3_period=200;
extern   int Stochastic_period=30;
extern   int CCI_period=50;
extern   int RSI_period=14;
extern   int MACD_period=20;

extern string note6="Trend Score Levels";  //fine tune the trend strength
extern string note7="0=Strong Down 10=Neutral 20=Strong Up";
extern   int scoreHighest=18;
extern   int scoreHigh=15;
int scoreMid=10;
extern   int scoreLow=5;
extern   int scoreLowest=2;


//string note1="macd:";
 int FastEMA=12;
 int SlowEMA=26;
 int SignalSMA=9;
 
int FSize=10;

string note8="Colors";
color RectClr=Gray;
extern color TxtClr=White;          //Text Color
extern color High_up_color=Lime;    //Strong Buy Color
extern color UpClr=DarkGreen;       //Weak Buy Color
extern color DnClr=FireBrick;       //Weak Sell Color
extern color High_down_color=Red;   //Strong Sell Color
extern color neutralClr=Gray;       //Neutral Color

 bool White_Chart_Theme=false;
 color RectClr1=Gray;
 color TxtClr1=Gray;
 color UpClr1=Lime;
 color DnClr1=Red;
 color FlatClr=DodgerBlue;

int codeAO,codeAO2,codeAO3,codeAO4,codeAO5,codeAO6,codeao7,codeao8,codeao9,
codeAC,codeMACD,
codeSTO,codeSTO2,codeSTO3,codeSTO4,codeSTO5,codeSTO6,codesto7,codesto8,codesto9,
codecci,codecci2,codecci3,codecci4,codecci5,codecci6,codecci7,codecci8,codecci9,
codersi,codersi2,codersi3,codersi4,codersi5,codersi6,codersi7,codersi8,codersi9,
codemacd,codemacd2,codemacd3,codemacd4,codemacd5,codemacd6,codemacd7,codemacd8,codemacd9,
codescoreM1,codescoreM5,codescoreM15,codescoreM30,codescoreH1,codescoreH4,codescoreD1,codescoreW1,codescoreMN,
lastBarM1, lastBarM5, lastBarM15, lastBarM30, lastBarH1, lastBarH4, lastBarD1,lastBarW1, lastBarMN,

scoreM1,scoreM5,scoreM15,scoreM30,scoreH1,scoreH4,scoreD1,scoreW1, scoreMN, totalScore;

color ClrAO,ClrAO2,ClrAO3,ClrAO4,ClrAO5,ClrAO6,clrao7,clrao8,clrao9,
ClrAC,ClrMACD,
ClrSTO,ClrSTO2,ClrSTO3,ClrSTO4,ClrSTO5,ClrSTO6,clrsto7,clrsto8,clrsto9,
clrcci,clrcci2,clrcci3,clrcci4,clrcci5,clrcci6,clrcci7,clrcci8,clrcci9,
clrrsi,clrrsi2,clrrsi3,clrrsi4,clrrsi5,clrrsi6,clrrsi7,clrrsi8,clrrsi9,
clrmacd,clrmacd2,clrmacd3,clrmacd4,clrmacd5,clrmacd6,clrmacd7,clrmacd8,clrmacd9,
clrscoreM1,clrscoreM5,clrscoreM15,clrscoreM30,clrscoreH1,clrscoreH4,clrscoreD1,clrscoreW1, clrscoreMN;// ***********FINISH


//bool Alert_=False;
//color Alert_Clr=Red;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    

      
      if(White_Chart_Theme)
            {
                RectClr=RectClr1;
                TxtClr=TxtClr1;
                UpClr=UpClr1;
                DnClr=DnClr1;
            }
       
       DrawPanel();
      
      
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Delete_My_Obj(Pref);
 
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
 if (CurrentSymbol==True) //use current chart symbol or selected symbol
   symbol1=_Symbol;
   else
   symbol1=symbol;
    
   
    
//   int    counted_bars=IndicatorCounted();



//M1 --------------------------------------------------------------------------------------------


   double ema1,ema2,sto, cci, rsi, macd, macds, ema3;
   ema1=iMA(symbol1,1,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema2=iMA(symbol1,1,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema3=iMA(symbol1,1,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto =iStochastic(symbol1,1,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);   
   cci =iCCI(symbol1,1,CCI_period,PRICE_CLOSE,0); 
   rsi =iRSI(symbol1,1,RSI_period,PRICE_CLOSE,0); 
   macd=iMACD(symbol1,1,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macds=iMACD(symbol1,1,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreM1=scoreMid;

      if ( ema2>ema1 && ema1>ema3 )       {codeAO=arrowCodeUp; ClrAO=High_up_color; scoreM1+=2; } 
      else 
      if ( ema2<ema1 && ema1<ema3 )       {codeAO=arrowCodeDown; ClrAO=High_down_color; scoreM1-=2; } 
      else
      if ( ema2>ema1 )                    {codeAO=arrowCodeUp; ClrAO=UpClr; scoreM1+=1; } 
      else
      if ( ema2<ema1 )                    {codeAO=arrowCodeDown; ClrAO=DnClr; scoreM1-=1; } 
  
      if ( sto>80 )                       {codeSTO=arrowCodeUp; ClrSTO=High_up_color; scoreM1+=2;}     
      if ( sto>50 && sto<80 )             {codeSTO=arrowCodeUp; ClrSTO=UpClr; scoreM1+=1;}
      if ( sto<50 && sto>20)              {codeSTO=arrowCodeDown; ClrSTO=DnClr; scoreM1-=1;}
      if ( sto<20 )                       {codeSTO=arrowCodeDown; ClrSTO=High_down_color; scoreM1-=2;}
      
      if ( cci>0 && cci<100 )             {codecci=arrowCodeUp; clrcci=UpClr;scoreM1+=1;}
      if ( cci<0 && cci>-100 )            {codecci=arrowCodeDown; clrcci=DnClr;scoreM1-=1;}
      if ( cci>100)                       {codecci=arrowCodeUp; clrcci=High_up_color;scoreM1+=2;}
      if ( cci<-100)                      {codecci=arrowCodeDown; clrcci=High_down_color;scoreM1-=2;}
      
      if ( rsi>50 && rsi<65 )             {codersi=arrowCodeUp; clrrsi=UpClr;scoreM1+=1;}
      if ( rsi<50 && rsi>35 )             {codersi=arrowCodeDown; clrrsi=DnClr;scoreM1-=1;}
      if ( rsi<35 )                       {codersi=arrowCodeDown; clrrsi=High_down_color; scoreM1-=2; }
      if ( rsi>65 )                       {codersi=arrowCodeUp; clrrsi=High_up_color;scoreM1+=2; }
      
      if ( macd>0 && macd<macds )         {codemacd=arrowCodeUp; clrmacd=UpClr;scoreM1+=1;}
      if ( macd<0 && macd>macds )         {codemacd=arrowCodeDown; clrmacd=DnClr;scoreM1-=1;}
      if ( macd<0 && macd<macds )         {codemacd=arrowCodeDown; clrmacd=High_down_color; scoreM1-=2;}
      if ( macd>0 && macd>macds )         {codemacd=arrowCodeUp; clrmacd=High_up_color; scoreM1+=2;}
      
      if (scoreM1>=scoreHighest)                     {codescoreM1=arrowCodeUp; clrscoreM1=High_up_color;}
      if (scoreM1>=scoreHigh && scoreM1<scoreHighest)       {codescoreM1=arrowCodeUp; clrscoreM1=UpClr;}
      if (scoreM1>=scoreMid && scoreM1<scoreHigh)       {codescoreM1=arrowCodeUp; clrscoreM1=neutralClr;}
      if (scoreM1>=scoreLow && scoreM1<scoreMid)       {codescoreM1=arrowCodeDown; clrscoreM1=neutralClr;}
      if (scoreM1>=scoreLowest && scoreM1<scoreLow)       {codescoreM1=arrowCodeDown; clrscoreM1=DnClr;}
      if (scoreM1<scoreLowest)                     {codescoreM1=arrowCodeDown; clrscoreM1=High_down_color;}
      
      //M5 --------------------------------------------------------------------------------------------

   double ema12,ema22,sto2, cci2, rsi2, macd2, macd2s, ema32;
   ema12=iMA(symbol1,5,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema22=iMA(symbol1,5,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema32=iMA(symbol1,5,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto2=iStochastic(symbol1,5,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);      
   cci2 =iCCI(symbol1,5,CCI_period,PRICE_CLOSE,0);  
   rsi2 =iRSI(symbol1,5,RSI_period,PRICE_CLOSE,0); 
   macd2=iMACD(symbol1,5,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macd2s=iMACD(symbol1,5,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreM5=scoreMid;
   
      if ( ema22>ema12 && ema12>ema32 )   {codeAO2=arrowCodeUp; ClrAO2=High_up_color; scoreM5+=2;} 
      else 
      if ( ema22<ema12 && ema12<ema32 )   {codeAO2=arrowCodeDown; ClrAO2=High_down_color; scoreM5-=2;} 
      else
      if ( ema22>ema12 )                  {codeAO2=arrowCodeUp; ClrAO2=UpClr; scoreM5+=1;} 
      else
      if ( ema22<ema12 )                  {codeAO2=arrowCodeDown; ClrAO2=DnClr; scoreM5-=1;} 
      
      if ( sto2>80 )                      {codeSTO2=arrowCodeUp; ClrSTO2=High_up_color; scoreM5+=2;}     
      if ( sto2>50 && sto2<80 )           {codeSTO2=arrowCodeUp; ClrSTO2=UpClr; scoreM5+=1;}
      if ( sto2<50 && sto2>20)            {codeSTO2=arrowCodeDown; ClrSTO2=DnClr; scoreM5-=1;}
      if ( sto2<20 )                      {codeSTO2=arrowCodeDown; ClrSTO2=High_down_color; scoreM5-=2;}
      
      if ( cci2>0 && cci2<100 )           {codecci2=arrowCodeUp; clrcci2=UpClr; scoreM5+=1;}
      if ( cci2<0 && cci2>-100 )          {codecci2=arrowCodeDown; clrcci2=DnClr; scoreM5-=1;}
      if ( cci2>100)                      {codecci2=arrowCodeUp; clrcci2=High_up_color; scoreM5+=2;}
      if ( cci2<-100)                     {codecci2=arrowCodeDown; clrcci2=High_down_color; scoreM5-=2;}
      
      if ( rsi2>50 && rsi2<65 )           {codersi2=arrowCodeUp; clrrsi2=UpClr; scoreM5+=1;}
      if ( rsi2<50 && rsi2>35 )           {codersi2=arrowCodeDown; clrrsi2=DnClr; scoreM5-=1;}
      if ( rsi2<35 )                      {codersi2=arrowCodeDown; clrrsi2=High_down_color; scoreM5-=2;}
      if ( rsi2>65 )                      {codersi2=arrowCodeUp; clrrsi2=High_up_color; scoreM5+=2; }
      
      if ( macd2>0 && macd2<macd2s )      {codemacd2=arrowCodeUp; clrmacd2=UpClr; scoreM5+=1;}
      if ( macd2<0 && macd2>macd2s )      {codemacd2=arrowCodeDown; clrmacd2=DnClr; scoreM5-=1;}
      if ( macd2<0 && macd2<macd2s )      {codemacd2=arrowCodeDown; clrmacd2=High_down_color; scoreM5-=2;}
      if ( macd2>0 && macd2>macd2s )      {codemacd2=arrowCodeUp; clrmacd2=High_up_color; scoreM5+=2;}
      
      if (scoreM5>=scoreHighest)                     {codescoreM5=arrowCodeUp; clrscoreM5=High_up_color;}
      if (scoreM5>=scoreHigh && scoreM5<scoreHighest)       {codescoreM5=arrowCodeUp; clrscoreM5=UpClr;}
      if (scoreM5>=scoreMid && scoreM5<scoreHigh)       {codescoreM5=arrowCodeUp; clrscoreM5=neutralClr;}
      if (scoreM5>=scoreLow && scoreM5<scoreMid)       {codescoreM5=arrowCodeDown; clrscoreM5=neutralClr;}
      if (scoreM5>=scoreLowest && scoreM5<scoreLow)       {codescoreM5=arrowCodeDown; clrscoreM5=DnClr;}
      if (scoreM5<scoreLowest)                     {codescoreM5=arrowCodeDown; clrscoreM5=High_down_color;}

        
        //M15 --------------------------------------------------------------------------------------------
         
   double ema13,ema23,sto3, cci3, rsi3,macd3,macd3s,ema33;
   ema13=iMA(symbol1,15,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema23=iMA(symbol1,15,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema33=iMA(symbol1,15,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto3=iStochastic(symbol1,15,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);      
   cci3 =iCCI(symbol1,15,CCI_period,PRICE_CLOSE,0);  
   rsi3 =iRSI(symbol1,15,RSI_period,PRICE_CLOSE,0); 
   macd3=iMACD(symbol1,15,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macd3s=iMACD(symbol1,15,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreM15=scoreMid;
  
      if ( ema23>ema13 && ema13>ema33 )   {codeAO3=arrowCodeUp; ClrAO3=High_up_color; scoreM15+=2; } 
      else 
      if ( ema23<ema13 && ema13<ema33 )   {codeAO3=arrowCodeDown; ClrAO3=High_down_color; scoreM15-=2; } 
      else
      if ( ema23>ema13 )                  {codeAO3=arrowCodeUp; ClrAO3=UpClr; scoreM15+=1; } 
      else
      if ( ema23<ema13 )                  {codeAO3=arrowCodeDown; ClrAO3=DnClr; scoreM15-=1; } 
      
      if ( sto3>80 )                      {codeSTO3=arrowCodeUp; ClrSTO3=High_up_color; scoreM15+=2;}     
      if ( sto3>50 && sto3<80 )           {codeSTO3=arrowCodeUp; ClrSTO3=UpClr; scoreM15+=1;}
      if ( sto3<50 && sto3>20)            {codeSTO3=arrowCodeDown; ClrSTO3=DnClr; scoreM15-=1;}
      if ( sto3<20 )                      {codeSTO3=arrowCodeDown; ClrSTO3=High_down_color; scoreM15-=2;}
      
      if ( cci3>0 && cci3<100 )           {codecci3=arrowCodeUp; clrcci3=UpClr; scoreM15+=1;}
      if ( cci3<0 && cci3>-100 )          {codecci3=arrowCodeDown; clrcci3=DnClr; scoreM15-=1;}
      if ( cci3>100)                      {codecci3=arrowCodeUp; clrcci3=High_up_color; scoreM15+=2;}
      if ( cci3<-100)                     {codecci3=arrowCodeDown; clrcci3=High_down_color; scoreM15-=2;}
      
      if ( rsi3>50 && rsi3<65 )           {codersi3=arrowCodeUp; clrrsi3=UpClr; scoreM15+=1;}
      if ( rsi3<50 && rsi3>35 )           {codersi3=arrowCodeDown; clrrsi3=DnClr; scoreM15-=1;}
      if ( rsi3<35 )                      {codersi3=arrowCodeDown; clrrsi3=High_down_color; scoreM15-=2; }
      if ( rsi3>65 )                      {codersi3=arrowCodeUp; clrrsi3=High_up_color; scoreM15+=2; }
      
      if ( macd3>0 && macd3<macd3s )      {codemacd3=arrowCodeUp; clrmacd3=UpClr; scoreM15+=1;}
      if ( macd3<0 && macd3>macd3s )      {codemacd3=arrowCodeDown; clrmacd3=DnClr; scoreM15-=1;}
      if ( macd3<0 && macd3<macd3s )      {codemacd3=arrowCodeDown; clrmacd3=High_down_color; scoreM15-=2;}
      if ( macd3>0 && macd3>macd3s )      {codemacd3=arrowCodeUp; clrmacd3=High_up_color; scoreM15+=2;}
      
      if (scoreM15>=scoreHighest)                    {codescoreM15=arrowCodeUp; clrscoreM15=High_up_color;}
      if (scoreM15>=scoreHigh && scoreM15<scoreHighest)     {codescoreM15=arrowCodeUp; clrscoreM15=UpClr;}
      if (scoreM15>=scoreMid && scoreM15<scoreHigh)     {codescoreM15=arrowCodeUp; clrscoreM15=neutralClr;}
      if (scoreM15>=scoreLow && scoreM15<scoreMid)     {codescoreM15=arrowCodeDown; clrscoreM15=neutralClr;}
      if (scoreM15>=scoreLowest && scoreM15<scoreLow)     {codescoreM15=arrowCodeDown; clrscoreM15=DnClr;}
      if (scoreM15<scoreLowest)                    {codescoreM15=arrowCodeDown; clrscoreM15=High_down_color;}

//M30 --------------------------------------------------------------------------------------------


   double ema14,ema24,sto4, cci4, rsi4,macd4,macd4s,ema34;
   ema14=iMA(symbol1,30,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema24=iMA(symbol1,30,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema34=iMA(symbol1,30,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto4=iStochastic(symbol1,30,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);      
   cci4 =iCCI(symbol1,30,CCI_period,PRICE_CLOSE,0);  
   rsi4 =iRSI(symbol1,30,RSI_period,PRICE_CLOSE,0); 
   macd4=iMACD(symbol1,30,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macd4s=iMACD(symbol1,30,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreM30=scoreMid;
   
      if ( ema24>ema14 && ema14>ema34 )   {codeAO4=arrowCodeUp; ClrAO4=High_up_color; scoreM30+=2;} 
      else 
      if ( ema24<ema14 && ema14<ema34 )   {codeAO4=arrowCodeDown; ClrAO4=High_down_color; scoreM30-=2;} 
      else
      if ( ema24>ema14 )                  {codeAO4=arrowCodeUp; ClrAO4=UpClr; scoreM30+=1; } 
      else
      if ( ema24<ema14 )                  {codeAO4=arrowCodeDown; ClrAO4=DnClr;  scoreM30-=1;} 
      
      if ( sto4>80 )                      {codeSTO4=arrowCodeUp; ClrSTO4=High_up_color; scoreM30+=2;}     
      if ( sto4>50 && sto4<80 )           {codeSTO4=arrowCodeUp; ClrSTO4=UpClr;scoreM30+=1;}
      if ( sto4<50 && sto4>20)            {codeSTO4=arrowCodeDown; ClrSTO4=DnClr;scoreM30-=1;}
      if ( sto4<20 )                      {codeSTO4=arrowCodeDown; ClrSTO4=High_down_color; scoreM30-=2;}
      
      if ( cci4>0 && cci4<100 )           {codecci4=arrowCodeUp; clrcci4=UpClr;scoreM30+=1;}
      if ( cci4<0 && cci4>-100 )          {codecci4=arrowCodeDown; clrcci4=DnClr;scoreM30-=1;}
      if ( cci4>100)                      {codecci4=arrowCodeUp; clrcci4=High_up_color; scoreM30+=2;}
      if ( cci4<-100)                     {codecci4=arrowCodeDown; clrcci4=High_down_color; scoreM30-=2;}
      
      if ( rsi4>50 && rsi4<65 )           {codersi4=arrowCodeUp; clrrsi4=UpClr;scoreM30+=1;}
      if ( rsi4<50 && rsi4>35 )           {codersi4=arrowCodeDown; clrrsi4=DnClr;scoreM30-=1;}
      if ( rsi4<35 )                      {codersi4=arrowCodeDown; clrrsi4=High_down_color; scoreM30-=2; }
      if ( rsi4>65 )                      {codersi4=arrowCodeUp; clrrsi4=High_up_color; scoreM30+=2; }
      
      if ( macd4>0 && macd4<macd4s )      {codemacd4=arrowCodeUp; clrmacd4=UpClr;scoreM30+=1;}
      if ( macd4<0 && macd4>macd4s )      {codemacd4=arrowCodeDown; clrmacd4=DnClr;scoreM30-=1;}
      if ( macd4<0 && macd4<macd4s )      {codemacd4=arrowCodeDown; clrmacd4=High_down_color; scoreM30-=2;}
      if ( macd4>0 && macd4>macd4s )      {codemacd4=arrowCodeUp; clrmacd4=High_up_color; scoreM30+=2;}
      
      if (scoreM30>=scoreHighest)                    {codescoreM30=arrowCodeUp; clrscoreM30=High_up_color;}
      if (scoreM30>=scoreHigh && scoreM30<scoreHighest)     {codescoreM30=arrowCodeUp; clrscoreM30=UpClr;}
      if (scoreM30>=scoreMid && scoreM30<scoreHigh)     {codescoreM30=arrowCodeUp; clrscoreM30=neutralClr;}
      if (scoreM30>=scoreLow && scoreM30<scoreMid)     {codescoreM30=arrowCodeDown; clrscoreM30=neutralClr;}
      if (scoreM30>=scoreLowest && scoreM30<scoreLow)     {codescoreM30=arrowCodeDown; clrscoreM30=DnClr;}
      if (scoreM30<scoreLowest)                    {codescoreM30=arrowCodeDown; clrscoreM30=High_down_color;}
      
      


//H1 --------------------------------------------------------------------------------------------

   double ema15,ema25,sto5, cci5, rsi5,macd5,macd5s,ema35;
   ema15=iMA(symbol1,60,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema25=iMA(symbol1,60,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema35=iMA(symbol1,60,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto5=iStochastic(symbol1,60,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);      
   cci5 =iCCI(symbol1,60,CCI_period,PRICE_CLOSE,0);  
   rsi5 =iRSI(symbol1,60,RSI_period,PRICE_CLOSE,0); 
   macd5=iMACD(symbol1,60,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macd5s=iMACD(symbol1,60,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreH1=scoreMid;
   
      if ( ema25>ema15 && ema15>ema35 )   {codeAO5=arrowCodeUp; ClrAO5=High_up_color; scoreH1+=2;} 
      else 
      if ( ema25<ema15 && ema15<ema35 )   {codeAO5=arrowCodeDown; ClrAO5=High_down_color; scoreH1-=2;} 
      else
      if ( ema25>ema15 )                  {codeAO5=arrowCodeUp; ClrAO5=UpClr; scoreH1+=1;} 
      else
      if ( ema25<ema15 )                  {codeAO5=arrowCodeDown; ClrAO5=DnClr; scoreH1-=1;} 
      
      if ( sto5>80 )                      {codeSTO5=arrowCodeUp; ClrSTO5=High_up_color; scoreH1+=2;}     
      if ( sto5>50 && sto5<80 )           {codeSTO5=arrowCodeUp; ClrSTO5=UpClr; scoreH1+=1;}
      if ( sto5<50 && sto5>20)            {codeSTO5=arrowCodeDown; ClrSTO5=DnClr; scoreH1-=1;}
      if ( sto5<20 )                      {codeSTO5=arrowCodeDown; ClrSTO5=High_down_color; scoreH1-=2;}
      
      if ( cci5>0 && cci5<100 )           {codecci5=arrowCodeUp; clrcci5=UpClr; scoreH1+=1;}
      if ( cci5<0 && cci5>-100 )          {codecci5=arrowCodeDown; clrcci5=DnClr; scoreH1-=1;}
      if ( cci5>100)                      {codecci5=arrowCodeUp; clrcci5=High_up_color; scoreH1+=2;}
      if ( cci5<-100)                     {codecci5=arrowCodeDown; clrcci5=High_down_color; scoreH1-=2;}
      
      if ( rsi5>50 && rsi5<65 )           {codersi5=arrowCodeUp; clrrsi5=UpClr; scoreH1+=1;}
      if ( rsi5<50 && rsi5>35 )           {codersi5=arrowCodeDown; clrrsi5=DnClr; scoreH1-=1;}
      if ( rsi5<35 )                      {codersi5=arrowCodeDown; clrrsi5=High_down_color; scoreH1-=2;}
      if ( rsi5>65 )                      {codersi5=arrowCodeUp; clrrsi5=High_up_color; scoreH1+=2;}
      
      if ( macd5>0 && macd5<macd5s )      {codemacd5=arrowCodeUp; clrmacd5=UpClr; scoreH1+=1;}
      if ( macd5<0 && macd5>macd5s )      {codemacd5=arrowCodeDown; clrmacd5=DnClr; scoreH1-=1;}
      if ( macd5<0 && macd5<macd5s )      {codemacd5=arrowCodeDown; clrmacd5=High_down_color; scoreH1-=2;}
      if ( macd5>0 && macd5>macd5s )      {codemacd5=arrowCodeUp; clrmacd5=High_up_color; scoreH1+=2;}
      
      if (scoreH1>=scoreHighest)                     {codescoreH1=arrowCodeUp; clrscoreH1=High_up_color;}
      if (scoreH1>=scoreHigh && scoreH1<scoreHighest)       {codescoreH1=arrowCodeUp; clrscoreH1=UpClr;}
      if (scoreH1>=scoreMid && scoreH1<scoreHigh)       {codescoreH1=arrowCodeUp; clrscoreH1=neutralClr;}
      if (scoreH1>=scoreLow && scoreH1<scoreMid)       {codescoreH1=arrowCodeDown; clrscoreH1=neutralClr;}
      if (scoreH1>=scoreLowest && scoreH1<scoreLow)       {codescoreH1=arrowCodeDown; clrscoreH1=DnClr;}
      if (scoreH1<scoreLowest)                     {codescoreH1=arrowCodeDown; clrscoreH1=High_down_color;}


//H4 --------------------------------------------------------------------------------------------

   double ema16,ema26,sto6, cci6, rsi6,macd6,macd6s,ema36;
   ema16=iMA(symbol1,240,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema26=iMA(symbol1,240,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema36=iMA(symbol1,240,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto6=iStochastic(symbol1,240,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);      
   cci6 =iCCI(symbol1,240,CCI_period,PRICE_CLOSE,0);  
   rsi6 =iRSI(symbol1,240,RSI_period,PRICE_CLOSE,0); 
   macd6=iMACD(symbol1,240,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macd6s=iMACD(symbol1,240,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreH4=scoreMid;
  
      if ( ema26>ema16 && ema16>ema36 )   {codeAO6=arrowCodeUp; ClrAO6=High_up_color; scoreH4+=2;} 
      else 
      if ( ema26<ema16 && ema16<ema36 )   {codeAO6=arrowCodeDown; ClrAO6=High_down_color; scoreH4-=2;} 
      else
      if ( ema26>ema16 )                  {codeAO6=arrowCodeUp; ClrAO6=UpClr; scoreH4+=1;} 
      else
      if ( ema26<ema16 )                  {codeAO6=arrowCodeDown; ClrAO6=DnClr; scoreH4-=1;} 
      
      if ( sto6>80 )                      {codeSTO6=arrowCodeUp; ClrSTO6=High_up_color; scoreH4+=2;}     
      if ( sto6>50 && sto6<80 )           {codeSTO6=arrowCodeUp; ClrSTO6=UpClr; scoreH4+=1;}
      if ( sto6<50 && sto6>20)            {codeSTO6=arrowCodeDown; ClrSTO6=DnClr; scoreH4-=1;}
      if ( sto6<20 )                      {codeSTO6=arrowCodeDown; ClrSTO6=High_down_color; scoreH4-=2;}
      
      if ( cci6>0 && cci6<100 )           {codecci6=arrowCodeUp; clrcci6=UpClr; scoreH4+=1;}
      if ( cci6<0 && cci6>-100 )          {codecci6=arrowCodeDown; clrcci6=DnClr; scoreH4-=1;}
      if ( cci6>100)                      {codecci6=arrowCodeUp; clrcci6=High_up_color; scoreH4+=2;}
      if ( cci6<-100)                     {codecci6=arrowCodeDown; clrcci6=High_down_color; scoreH4-=2;}
      
      if ( rsi6>50 && rsi6<65 )           {codersi6=arrowCodeUp; clrrsi6=UpClr; scoreH4+=1;}
      if ( rsi6<50 && rsi6>35 )           {codersi6=arrowCodeDown; clrrsi6=DnClr; scoreH4-=1;}
      if ( rsi6<35 )                      {codersi6=arrowCodeDown; clrrsi6=High_down_color; scoreH4-=2;}
      if ( rsi6>65 )                      {codersi6=arrowCodeUp; clrrsi6=High_up_color; scoreH4+=2;}
      
      if ( macd6>0 && macd6<macd6s )      {codemacd6=arrowCodeUp; clrmacd6=UpClr; scoreH4+=1;}
      if ( macd6<0 && macd6>macd6s )      {codemacd6=arrowCodeDown; clrmacd6=DnClr; scoreH4-=1;}
      if ( macd6<0 && macd6<macd6s )      {codemacd6=arrowCodeDown; clrmacd6=High_down_color; scoreH4-=2;}
      if ( macd6>0 && macd6>macd6s )      {codemacd6=arrowCodeUp; clrmacd6=High_up_color; scoreH4+=2;}
      
      if (scoreH4>=scoreHighest)                     {codescoreH4=arrowCodeUp; clrscoreH4=High_up_color;}
      if (scoreH4>=scoreHigh && scoreH4<scoreHighest)       {codescoreH4=arrowCodeUp; clrscoreH4=UpClr;}
      if (scoreH4>=scoreMid && scoreH4<scoreHigh)       {codescoreH4=arrowCodeUp; clrscoreH4=neutralClr;}
      if (scoreH4>=scoreLow && scoreH4<scoreMid)       {codescoreH4=arrowCodeDown; clrscoreH4=neutralClr;}
      if (scoreH4>=scoreLowest && scoreH4<scoreLow)       {codescoreH4=arrowCodeDown; clrscoreH4=DnClr;}
      if (scoreH4<scoreLowest)                     {codescoreH4=arrowCodeDown; clrscoreH4=High_down_color;}
      
      
//D1 --------------------------------------------------------------------------------------------
      
   double ema17,ema27,sto7, cci7, rsi7,macd7,macd7s,ema37;
   ema17=iMA(symbol1,1440,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema27=iMA(symbol1,1440,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema37=iMA(symbol1,1440,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto7 =iStochastic(symbol1,1440,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);   
   cci7 =iCCI(symbol1,1440,CCI_period,PRICE_CLOSE,0);  
   rsi7 =iRSI(symbol1,1440,RSI_period,PRICE_CLOSE,0); 
   macd7=iMACD(symbol1,1440,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macd7s=iMACD(symbol1,1440,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreD1=scoreMid;
   
      if ( ema27>ema17 && ema17>ema37 )   {codeao7=arrowCodeUp; clrao7=High_up_color; scoreD1+=2;} 
      else 
      if ( ema27<ema17 && ema17<ema37 )   {codeao7=arrowCodeDown; clrao7=High_down_color; scoreD1-=2;} 
      else
      if ( ema27>ema17 )                  {codeao7=arrowCodeUp; clrao7=UpClr; scoreD1+=1;} 
      else
      if ( ema27<ema17 )                  {codeao7=arrowCodeDown; clrao7=DnClr; scoreD1-=1;} 

      if ( sto7>80 )                      {codesto7=arrowCodeUp; clrsto7=High_up_color; scoreD1+=2;}     
      if ( sto7>50 && sto7<80 )           {codesto7=arrowCodeUp; clrsto7=UpClr; scoreD1+=1;}
      if ( sto7<50 && sto7>20)            {codesto7=arrowCodeDown; clrsto7=DnClr; scoreD1-=1;}
      if ( sto7<20 )                      {codesto7=arrowCodeDown; clrsto7=High_down_color; scoreD1-=2;}
      
      if ( cci7>0 && cci7<100 )           {codecci7=arrowCodeUp; clrcci7=UpClr; scoreD1+=1;}
      if ( cci7<0 && cci7>-100 )          {codecci7=arrowCodeDown; clrcci7=DnClr; scoreD1-=1;}
      if ( cci7>100)                      {codecci7=arrowCodeUp; clrcci7=High_up_color; scoreD1+=2;}
      if ( cci7<-100)                     {codecci7=arrowCodeDown; clrcci7=High_down_color; scoreD1-=2;}
      
      if ( rsi7>50 && rsi7<65 )           {codersi7=arrowCodeUp; clrrsi7=UpClr; scoreD1+=1;}
      if ( rsi7<50 && rsi7>35 )           {codersi7=arrowCodeDown; clrrsi7=DnClr; scoreD1-=1;}
      if ( rsi7<35 )                      {codersi7=arrowCodeDown; clrrsi7=High_down_color; scoreD1-=2;}
      if ( rsi7>65 )                      {codersi7=arrowCodeUp; clrrsi7=High_up_color; scoreD1+=2; }
      
      if ( macd7>0 && macd7<macd7s )      {codemacd7=arrowCodeUp; clrmacd7=UpClr; scoreD1+=1;}
      if ( macd7<0 && macd7>macd7s )      {codemacd7=arrowCodeDown; clrmacd7=DnClr; scoreD1-=1;}
      if ( macd7<0 && macd7<macd7s )      {codemacd7=arrowCodeDown; clrmacd7=High_down_color; scoreD1-=2;}
      if ( macd7>0 && macd7>macd7s )      {codemacd7=arrowCodeUp; clrmacd7=High_up_color; scoreD1+=2;}
      
      if (scoreD1>=scoreHighest)                            {codescoreD1=arrowCodeUp; clrscoreD1=High_up_color;}
      if (scoreD1>=scoreHigh && scoreD1<scoreHighest)       {codescoreD1=arrowCodeUp; clrscoreD1=UpClr;}
      if (scoreD1>=scoreMid && scoreD1<scoreHigh)           {codescoreD1=arrowCodeUp; clrscoreD1=neutralClr;}
      if (scoreD1>=scoreLow && scoreD1<scoreMid)            {codescoreD1=arrowCodeDown; clrscoreD1=neutralClr;}
      if (scoreD1>=scoreLowest && scoreD1<scoreLow)         {codescoreD1=arrowCodeDown; clrscoreD1=DnClr;}
      if (scoreD1<scoreLowest)                              {codescoreD1=arrowCodeDown; clrscoreD1=High_down_color;}
      
//W1 --------------------------------------------------------------------------------------------
      
   double ema18,ema28,sto8, cci8, rsi8,macd8,macd8s,ema38;
   ema18=iMA(symbol1,10080,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema28=iMA(symbol1,10080,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema38=iMA(symbol1,10080,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto8 =iStochastic(symbol1,10080,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);   
   cci8 =iCCI(symbol1,10080,CCI_period,PRICE_CLOSE,0);  
   rsi8 =iRSI(symbol1,10080,RSI_period,PRICE_CLOSE,0); 
   macd8=iMACD(symbol1,10080,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
  macd8s=iMACD(symbol1,10080,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
  scoreW1=scoreMid;
   
      if ( ema28>ema18 && ema18>ema38 )   {codeao8=arrowCodeUp; clrao8=High_up_color; scoreW1+=2;} 
      else 
      if ( ema28<ema18 && ema18<ema38 )   {codeao8=arrowCodeDown; clrao8=High_down_color; scoreW1-=2;} 
      else
      if ( ema28>ema18 )                  {codeao8=arrowCodeUp; clrao8=UpClr;  scoreW1+=1;} 
      else
      if ( ema28<ema18 )                  {codeao8=arrowCodeDown; clrao8=DnClr; scoreW1-=1;} 

      if ( sto8>80 )                      {codesto8=arrowCodeUp; clrsto8=High_up_color; scoreW1+=2;}     
      if ( sto8>50 && sto8<80 )           {codesto8=arrowCodeUp; clrsto8=UpClr; scoreW1+=1;}
      if ( sto8<50 && sto8>20)            {codesto8=arrowCodeDown; clrsto8=DnClr; scoreW1-=1;}
      if ( sto8<20 )                      {codesto8=arrowCodeDown; clrsto8=High_down_color; scoreW1-=2;}
      
      if ( cci8>0 && cci8<100 )           {codecci8=arrowCodeUp; clrcci8=UpClr; scoreW1+=1;}
      if ( cci8<0 && cci8>-100 )          {codecci8=arrowCodeDown; clrcci8=DnClr; scoreW1-=1;}
      if ( cci8>100)                      {codecci8=arrowCodeUp; clrcci8=High_up_color; scoreW1+=2;}
      if ( cci8<-100)                     {codecci8=arrowCodeDown; clrcci8=High_down_color; scoreW1-=2;}
      
      if ( rsi8>50 && rsi8<65 )           {codersi8=arrowCodeUp; clrrsi8=UpClr; scoreW1+=1;}
      if ( rsi8<50 && rsi8>35 )           {codersi8=arrowCodeDown; clrrsi8=DnClr; scoreW1-=1;}
      if ( rsi8<35 )                      {codersi8=arrowCodeDown; clrrsi8=High_down_color; scoreW1-=2;}
      if ( rsi8>65 )                      {codersi8=arrowCodeUp; clrrsi8=High_up_color; scoreW1+=2;}
      
      if ( macd8>0 && macd8<macd8s )      {codemacd8=arrowCodeUp; clrmacd8=UpClr; scoreW1+=1;}
      if ( macd8<0 && macd8>macd8s )      {codemacd8=arrowCodeDown; clrmacd8=DnClr; scoreW1-=1;}
      if ( macd8<0 && macd8<macd8s )      {codemacd8=arrowCodeDown; clrmacd8=High_down_color; scoreW1-=2;}
      if ( macd8>0 && macd8>macd8s )      {codemacd8=arrowCodeUp; clrmacd8=High_up_color; scoreW1+=2;}
      
      if (scoreW1>=scoreHighest)                            {codescoreW1=arrowCodeUp; clrscoreW1=High_up_color;}
      if (scoreW1>=scoreHigh && scoreW1<scoreHighest)       {codescoreW1=arrowCodeUp; clrscoreW1=UpClr;}
      if (scoreW1>=scoreMid && scoreW1<scoreHigh)           {codescoreW1=arrowCodeUp; clrscoreW1=neutralClr;}
      if (scoreW1>=scoreLow && scoreW1<scoreMid)            {codescoreW1=arrowCodeDown; clrscoreW1=neutralClr;}
      if (scoreW1>=scoreLowest && scoreW1<scoreLow)         {codescoreW1=arrowCodeDown; clrscoreW1=DnClr;}
      if (scoreW1<scoreLowest)                              {codescoreW1=arrowCodeDown; clrscoreW1=High_down_color;}
      


 //MN --------------------------------------------------------------------------------------------

   double ema19,ema29,sto9,cci9,rsi9,macd9,macd9s,ema39;
   ema19=iMA(symbol1,43200,EMA2_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema29=iMA(symbol1,43200,EMA1_period,0,MODE_EMA,PRICE_CLOSE,0);
   ema39=iMA(symbol1,43200,EMA3_period,0,MODE_EMA,PRICE_CLOSE,0);
   sto9 =iStochastic(symbol1,43200,Stochastic_period,3,3,MODE_SMA,0,MODE_MAIN,0);
   cci9 =iCCI(symbol1,43200,CCI_period,PRICE_CLOSE,0);
   rsi9 =iRSI(symbol1,43200,RSI_period,PRICE_CLOSE,0);
   macd9=iMACD(symbol1,43200,MACD_period,26,9,PRICE_CLOSE,MODE_MAIN,0);
   macd9s=iMACD(symbol1,43200,MACD_period,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   scoreMN=scoreMid;

   if(ema29>ema19 && ema19>ema39) {codeao9=arrowCodeUp; clrao9=High_up_color; scoreMN+=2;}
   else
   if(ema29<ema19 && ema19<ema39) {codeao9=arrowCodeDown; clrao9=High_down_color; scoreMN-=2;}
   else
   if(ema29>ema19) {codeao9=arrowCodeUp; clrao9=UpClr;  scoreMN+=1;}
   else
   if(ema29<ema19) {codeao9=arrowCodeDown; clrao9=DnClr; scoreMN-=1;}

   if( sto9>80 )                      {codesto9=arrowCodeUp; clrsto9=High_up_color; scoreMN+=2;}
   if( sto9>50 && sto9<80 )           {codesto9=arrowCodeUp; clrsto9=UpClr; scoreMN+=1;}
   if( sto9<50 && sto9>20)            {codesto9=arrowCodeDown; clrsto9=DnClr; scoreMN-=1;}
   if( sto9<20 )                      {codesto9=arrowCodeDown; clrsto9=High_down_color; scoreMN-=2;}

   if( cci9>0 && cci9<100 )           {codecci9=arrowCodeUp; clrcci9=UpClr; scoreMN+=1;}
   if( cci9<0 && cci9>-100 )          {codecci9=arrowCodeDown; clrcci9=DnClr; scoreMN-=1;}
   if( cci9>100)                      {codecci9=arrowCodeUp; clrcci9=High_up_color; scoreMN+=2;}
   if( cci9<-100)                     {codecci9=arrowCodeDown; clrcci9=High_down_color; scoreMN-=2;}

   if( rsi9>50 && rsi9<65 )           {codersi9=arrowCodeUp; clrrsi9=UpClr; scoreMN+=1;}
   if( rsi9<50 && rsi9>35 )           {codersi9=arrowCodeDown; clrrsi9=DnClr; scoreMN-=1;}
   if( rsi9<35 )                      {codersi9=arrowCodeDown; clrrsi9=High_down_color; scoreMN-=2;}
   if( rsi9>65 )                      {codersi9=arrowCodeUp; clrrsi9=High_up_color; scoreMN+=2;}

   if( macd9>0 && macd9<macd9s )      {codemacd9=arrowCodeUp; clrmacd9=UpClr; scoreMN+=1;}
   if( macd9<0 && macd9>macd9s )      {codemacd9=arrowCodeDown; clrmacd9=DnClr; scoreMN-=1;}
   if( macd9<0 && macd9<macd9s )      {codemacd9=arrowCodeDown; clrmacd9=High_down_color; scoreMN-=2;}
   if( macd9>0 && macd9>macd9s )      {codemacd9=arrowCodeUp; clrmacd9=High_up_color; scoreMN+=2;}

   if(scoreMN>=scoreHighest)                          {codescoreMN=arrowCodeUp; clrscoreMN=High_up_color;}
   if(scoreMN>=scoreHigh && scoreMN<scoreHighest)     {codescoreMN=arrowCodeUp; clrscoreMN=UpClr;}
   if(scoreMN>=scoreMid && scoreMN<scoreHigh)         {codescoreMN=arrowCodeUp; clrscoreMN=neutralClr;}
   if(scoreMN>=scoreLow && scoreMN<scoreMid)          {codescoreMN=arrowCodeDown; clrscoreMN=neutralClr;}
   if(scoreMN>=scoreLowest && scoreMN<scoreLow)       {codescoreMN=arrowCodeDown; clrscoreMN=DnClr;}
   if(scoreMN<scoreLowest)                            {codescoreMN=arrowCodeDown; clrscoreMN=High_down_color;}
   
   
   //total score-------------------------------------------------------------------------------------------------------------------

totalScore=scoreM1+scoreM5+scoreM15+scoreM30+scoreH1+scoreH4+scoreD1+scoreW1+scoreMN; //total score of all trend scores

/* scoreShortterm=scoreM1+scoreM5+scoreM15; 
scoreMidterm=scoreM30+scoreH1+scoreH4;
scoreLongterm=scoreD1+scoreW1+scoreMN;
*/


//-------------------------------------------------------------------------------------------------------------------------------
             
      DrawPanel();

   return(0);
  }
//+------------------------------------------------------------------+
int DrawText( string name, datetime T, double P, string Text, int code=0, color Clr=Green,  int Fsize=10, int Win=0)
   { 
      if (name=="") name="Text_"+T;
      
      int Error=ObjectFind(name);//  
   if (Error!=Win)//    .   :(
    { 
      ObjectCreate(name, OBJ_TEXT, Win, T, P);
      }
      
      ObjectSet(name, OBJPROP_TIME1, T);
      ObjectSet(name, OBJPROP_PRICE1, P);
      
      if(code==0)
      ObjectSetText(name, Text ,Fsize,"Arial",Clr);
      else
      ObjectSetText(name, CharToStr(code), Fsize,"Wingdings",Clr);
   }
   
//--------------------------------------
void DrawPanel()
{     
      if (drawSymbol==True)
       {
       DrawLabels(Pref+"Symbol",   Corner, X+(X_Space*0.11), Y+(Y_Space*0.08), symbol1,  0,TxtClr, 0, 10);
       }
      
      if (drawTimeframes==True)
      {
       DrawLabels(Pref+"M1",   Corner, X+(X_Space*0.1), Y+(Y_Space*0.15), " M1",  0,TxtClr, 0, 8);
       DrawLabels(Pref+"M5",   Corner, X+(X_Space*0.2), Y+(Y_Space*0.15), " M5",  0,TxtClr, 0, 8);
       DrawLabels(Pref+"M15",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.15), "M15", 0,TxtClr, 0, 8);
       DrawLabels(Pref+"M30",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.15), "M30", 0,TxtClr, 0, 8);
       DrawLabels(Pref+"H1",   Corner, X+(X_Space*0.5), Y+(Y_Space*0.15), " H1",  0,TxtClr, 0, 8);
       DrawLabels(Pref+"H4",   Corner, X+(X_Space*0.6), Y+(Y_Space*0.15), " H4",  0,TxtClr, 0, 8);
       DrawLabels(Pref+"D1",   Corner, X+(X_Space*0.7), Y+(Y_Space*0.15), " D1",  0,TxtClr, 0, 8);
       DrawLabels(Pref+"W1",   Corner, X+(X_Space*0.8), Y+(Y_Space*0.15), " W1",  0,TxtClr, 0, 8);
       DrawLabels(Pref+"MN",   Corner, X+(X_Space*0.9), Y+(Y_Space*0.15), " MN",  0,TxtClr, 0, 8);
       }
       
       if (drawLabels==True)
       {
       DrawLabels(Pref+"MA",  Corner, X+(X_Space), Y+5+(Y_Space*0.2), "MA", 0,TxtClr, 0, 10);
       DrawLabels(Pref+"Stoch",  Corner, X+(X_Space), Y+5+(Y_Space*0.3), "Stoch", 0,TxtClr, 0, 10);
       DrawLabels(Pref+"cci",  Corner, X+(X_Space), Y+5+(Y_Space*0.4), "CCI", 0,TxtClr, 0, 10);
       DrawLabels(Pref+"rsi",  Corner,X+(X_Space), Y+5+(Y_Space*0.5), "RSI", 0,TxtClr, 0, 10);
       DrawLabels(Pref+"macd",  Corner, X+(X_Space), Y+5+(Y_Space*0.6), "MACD", 0,TxtClr, 0, 10);
       DrawLabels(Pref+"Trend",  Corner, X+(X_Space), Y+5+(Y_Space*0.7), "Trend", 0,TxtClr, 0, 10);
       DrawLabels(Pref+"Score",  Corner, X+(X_Space), Y+5+(Y_Space*0.82), "Score", 0,TxtClr, 0, 10);
       }

     
       DrawLabels(Pref+"AO direction",   Corner, X+(X_Space*0.1), Y+(Y_Space*0.2), "", codeAO,ClrAO, 0, arrowSize);
       DrawLabels(Pref+"AO2 direction",  Corner, X+(X_Space*0.2), Y+(Y_Space*0.2), "", codeAO2,ClrAO2, 0, arrowSize);
       DrawLabels(Pref+"AO3 direction",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.2), "", codeAO3,ClrAO3, 0, arrowSize);
       DrawLabels(Pref+"AO4 direction",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.2), "", codeAO4,ClrAO4, 0, arrowSize);
       DrawLabels(Pref+"AO9 direction",  Corner, X+(X_Space*0.5), Y+(Y_Space*0.2), "", codeAO5,ClrAO5, 0, arrowSize);
       DrawLabels(Pref+"AO1 direction",  Corner, X+(X_Space*0.6), Y+(Y_Space*0.2), "", codeAO6,ClrAO6, 0, arrowSize);
       DrawLabels(Pref+"AO10 direction", Corner, X+(X_Space*0.7), Y+(Y_Space*0.2), "", codeao7,clrao7, 0, arrowSize);
       DrawLabels(Pref+"AO11 direction", Corner, X+(X_Space*0.8), Y+(Y_Space*0.2), "", codeao8,clrao8, 0, arrowSize);
       DrawLabels(Pref+"AO12 direction", Corner, X+(X_Space*0.9), Y+(Y_Space*0.2), "", codeao9,clrao9, 0, arrowSize);
       
       DrawLabels(Pref+"AO5 direction",  Corner, X+(X_Space*0.1), Y+(Y_Space*0.3), "", codeSTO,ClrSTO, 0, arrowSize);
       DrawLabels(Pref+"AO6 direction",  Corner, X+(X_Space*0.2), Y+(Y_Space*0.3), "", codeSTO2,ClrSTO2, 0, arrowSize);
       DrawLabels(Pref+"AO7 direction",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.3), "", codeSTO3,ClrSTO3, 0, arrowSize);
       DrawLabels(Pref+"AO8 direction",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.3), "", codeSTO4,ClrSTO4, 0, arrowSize);
       DrawLabels(Pref+"AO81 direction",  Corner, X+(X_Space*0.5), Y+(Y_Space*0.3), "", codeSTO5,ClrSTO5, 0, arrowSize);
       DrawLabels(Pref+"AO82 direction",  Corner, X+(X_Space*0.6), Y+(Y_Space*0.3), "", codeSTO6,ClrSTO6, 0, arrowSize);
       DrawLabels(Pref+"AO87 direction",  Corner, X+(X_Space*0.7), Y+(Y_Space*0.3), "", codesto7,clrsto7, 0, arrowSize);
       DrawLabels(Pref+"AO88 direction",  Corner, X+(X_Space*0.8), Y+(Y_Space*0.3), "", codesto8,clrsto8, 0, arrowSize);
       DrawLabels(Pref+"AO89 direction",  Corner, X+(X_Space*0.9), Y+(Y_Space*0.3), "", codesto9,clrsto9, 0, arrowSize);

       DrawLabels(Pref+"cci direction",   Corner, X+(X_Space*0.1), Y+(Y_Space*0.4), "",  codecci, clrcci, 0, arrowSize);
       DrawLabels(Pref+"cci2 direction",  Corner, X+(X_Space*0.2), Y+(Y_Space*0.4), "",  codecci2,clrcci2, 0, arrowSize);
       DrawLabels(Pref+"cci3 direction",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.4), "", codecci3,clrcci3, 0, arrowSize);
       DrawLabels(Pref+"cci4 direction",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.4), "", codecci4,clrcci4, 0, arrowSize);
       DrawLabels(Pref+"cci5 direction",  Corner, X+(X_Space*0.5), Y+(Y_Space*0.4), "", codecci5,clrcci5, 0, arrowSize);
       DrawLabels(Pref+"cci6 direction",  Corner, X+(X_Space*0.6), Y+(Y_Space*0.4), "", codecci6,clrcci6, 0, arrowSize);
       DrawLabels(Pref+"cci57 direction",  Corner, X+(X_Space*0.7), Y+(Y_Space*0.4), "", codecci7,clrcci7, 0, arrowSize);
       DrawLabels(Pref+"cci68 direction",  Corner, X+(X_Space*0.8), Y+(Y_Space*0.4), "", codecci8,clrcci8, 0, arrowSize);
       DrawLabels(Pref+"cci69 direction",  Corner, X+(X_Space*0.9), Y+(Y_Space*0.4), "", codecci9,clrcci9, 0, arrowSize);

       DrawLabels(Pref+"rsi direction",   Corner, X+(X_Space*0.1), Y+(Y_Space*0.5), "",  codersi, clrrsi, 0, arrowSize);
       DrawLabels(Pref+"rsi2 direction",  Corner, X+(X_Space*0.2), Y+(Y_Space*0.5), "",  codersi2,clrrsi2, 0, arrowSize);
       DrawLabels(Pref+"rsi3 direction",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.5), "", codersi3,clrrsi3, 0, arrowSize);
       DrawLabels(Pref+"rsi4 direction",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.5), "", codersi4,clrrsi4, 0, arrowSize);
       DrawLabels(Pref+"rsi5 direction",  Corner, X+(X_Space*0.5), Y+(Y_Space*0.5), "", codersi5,clrrsi5, 0, arrowSize);
       DrawLabels(Pref+"rsi6 direction",  Corner, X+(X_Space*0.6), Y+(Y_Space*0.5), "", codersi6,clrrsi6, 0, arrowSize);
       DrawLabels(Pref+"rsi57 direction",  Corner, X+(X_Space*0.7), Y+(Y_Space*0.5), "", codersi7,clrrsi7, 0, arrowSize);
       DrawLabels(Pref+"rsi68 direction",  Corner, X+(X_Space*0.8), Y+(Y_Space*0.5), "", codersi8,clrrsi8, 0, arrowSize);
       DrawLabels(Pref+"rsi69 direction",  Corner, X+(X_Space*0.9), Y+(Y_Space*0.5), "", codersi9,clrrsi9, 0, arrowSize);

       DrawLabels(Pref+"macdrsi direction",   Corner, X+(X_Space*0.1), Y+(Y_Space*0.6), "",  codemacd, clrmacd, 0, arrowSize);
       DrawLabels(Pref+"macdrsi2 direction",  Corner, X+(X_Space*0.2), Y+(Y_Space*0.6), "",  codemacd2,clrmacd2, 0, arrowSize);
       DrawLabels(Pref+"macdrsi3 direction",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.6), "", codemacd3,clrmacd3, 0, arrowSize);
       DrawLabels(Pref+"macdrsi4 direction",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.6), "", codemacd4,clrmacd4, 0, arrowSize);
       DrawLabels(Pref+"macdrsi5 direction",  Corner, X+(X_Space*0.5), Y+(Y_Space*0.6), "", codemacd5,clrmacd5, 0, arrowSize);
       DrawLabels(Pref+"macdrsi6 direction",  Corner, X+(X_Space*0.6), Y+(Y_Space*0.6), "", codemacd6,clrmacd6, 0, arrowSize);
       DrawLabels(Pref+"macdrsi57 direction",  Corner, X+(X_Space*0.7), Y+(Y_Space*0.6), "", codemacd7,clrmacd7, 0, arrowSize);
       DrawLabels(Pref+"macdrsi68 direction",  Corner, X+(X_Space*0.8), Y+(Y_Space*0.6), "", codemacd8,clrmacd8, 0, arrowSize);
       DrawLabels(Pref+"macdrsi69 direction",  Corner, X+(X_Space*0.9), Y+(Y_Space*0.6), "", codemacd9,clrmacd9, 0, arrowSize);
   
       
      
       //**************************** Trendscore**********************************************************************************************
       
       
       
       DrawLabels(Pref+"scoreM1 direction",   Corner, X+(X_Space*0.1),  Y+(Y_Space*0.7), "", codescoreM1,  clrscoreM1,  0, arrowSize);
       DrawLabels(Pref+"scoreM5 direction",   Corner, X+(X_Space*0.2),  Y+(Y_Space*0.7), "", codescoreM5,  clrscoreM5,  0, arrowSize);
       DrawLabels(Pref+"scoreM15 direction",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.7), "", codescoreM15, clrscoreM15, 0, arrowSize);
       DrawLabels(Pref+"scoreM30 direction",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.7), "", codescoreM30, clrscoreM30, 0, arrowSize);
       DrawLabels(Pref+"scoreH1 direction",   Corner, X+(X_Space*0.5), Y+(Y_Space*0.7), "", codescoreH1,  clrscoreH1,  0, arrowSize);
       DrawLabels(Pref+"scoreH4 direction",   Corner, X+(X_Space*0.6), Y+(Y_Space*0.7), "", codescoreH4,  clrscoreH4,  0, arrowSize);
       DrawLabels(Pref+"scoreD1 direction",   Corner, X+(X_Space*0.7), Y+(Y_Space*0.7), "", codescoreD1,  clrscoreD1,  0, arrowSize);
       DrawLabels(Pref+"scoreW1 direction",   Corner, X+(X_Space*0.8), Y+(Y_Space*0.7), "", codescoreW1,  clrscoreW1,  0, arrowSize);
       DrawLabels(Pref+"scoreMN direction",   Corner, X+(X_Space*0.9), Y+(Y_Space*0.7), "", codescoreMN,  clrscoreMN,  0, arrowSize);
       
       if (drawScore==True)
       {
       DrawLabels(Pref+"ScoreM1",   Corner, X+(X_Space*0.1),  Y+(Y_Space*0.85), scoreM1,  0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreM5",   Corner, X+(X_Space*0.2),  Y+(Y_Space*0.85), scoreM5,  0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreM15",  Corner, X+(X_Space*0.3), Y+(Y_Space*0.85), scoreM15, 0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreM30",  Corner, X+(X_Space*0.4), Y+(Y_Space*0.85), scoreM30, 0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreH1",   Corner, X+(X_Space*0.5), Y+(Y_Space*0.85), scoreH1,  0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreH4",   Corner, X+(X_Space*0.6), Y+(Y_Space*0.85), scoreH4,  0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreD1",   Corner, X+(X_Space*0.7), Y+(Y_Space*0.85), scoreD1,  0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreW1",   Corner, X+(X_Space*0.8), Y+(Y_Space*0.85), scoreW1,  0,TxtClr, 0, 10);
       DrawLabels(Pref+"ScoreMN",   Corner, X+(X_Space*0.9), Y+(Y_Space*0.85), scoreMN,  0,TxtClr, 0, 10);
       DrawLabels(Pref+"totalScore",   Corner, X+(X_Space*0.9), Y+(Y_Space*0.08), totalScore,  0,TxtClr, 0, 11);
        }
        
  
      

}

//---------------------------------
int DrawRect( string name, datetime T1, double P1,datetime T2, double P2,
                    color Clr=Green, int Width=1, string Text="", int Win=0)
   { 
      if (name=="") name="Text_"+T1;
      
      int Error=ObjectFind(name);//  
    if (Error!=Win)//    .   :(
    {  
      ObjectCreate(name, OBJ_RECTANGLE, Win,T1,P1,T2,P2);//  
    }
     
    ObjectSet(name, OBJPROP_TIME1 ,T1);
    ObjectSet(name, OBJPROP_PRICE1,P1);
    ObjectSet(name, OBJPROP_TIME2 ,T2);
    ObjectSet(name, OBJPROP_PRICE2,P2);
    ObjectSet(name,OBJPROP_BACK, false);
    ObjectSet(name,OBJPROP_STYLE,0);
    ObjectSet(name, OBJPROP_COLOR , Clr);
    ObjectSet(name, OBJPROP_WIDTH , Width);
    ObjectSetText(name,Text);
    

    
    }
///-----------------------
void Delete_My_Obj(string Prefix)
   {//Alert(ObjectsTotal());
   for(int k=ObjectsTotal()-1; k>=0; k--)  //     
     {
      string Obj_Name=ObjectName(k);   //   
      string Head=StringSubstr(Obj_Name,0,StringLen(Prefix));//   

      if (Head==Prefix)//  , ..
         {
         ObjectDelete(Obj_Name);
         //Alert(Head+";"+Prefix);
         }                
        
     }
   }

 
    
int DrawLabels(string name, int corn, int X, int Y, string Text, int code=0, color Clr=Green, int Win=0, int FSize=10)
   {
     int Error=ObjectFind(name);//  
   if (Error!=Win)//    .   :(
    {  
      ObjectCreate(name,OBJ_LABEL,Win, 0,0); //  
    }
     
     ObjectSet(name, OBJPROP_CORNER, corn);     //      
     ObjectSet(name, OBJPROP_XDISTANCE, X);  //     
     ObjectSet(name,OBJPROP_YDISTANCE,Y);//  Y   
     ObjectSetText(name,Text,FSize,"Arial",Clr);
          if(code==0)
      ObjectSetText(name, Text ,FSize,"Arial",Clr);
      else
      ObjectSetText(name, CharToStr(code), FSize,"Wingdings",Clr);
   }